local mod = ...



-- Job: Choir -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_MONASTICLIFE_CHOIR",
	JobName = "JOB_MONASTICLIFE_CHOIR_NAME",
	JobDescription = "JOB_MONASTICLIFE_CHOIR_DESC",
	IsLockedByDefault = true,
	DefaultBehavior = "BEHAVIOR_WORK",
	UseWorkplaceBehavior = true,
    ProductionDelay = 20, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE",
	},
})

mod:overrideAsset({
    Id = "MONK",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_MONASTICLIFE_CHOIR",
    },
})

mod:overrideAsset({
    Id = "MONK_PRIOR",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_MONASTICLIFE_CHOIR",
    },
})



-- Building Function: Choir -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_MONASTICLIFE_CHOIR",
    Name = "BUILDING_FUNCTION_MONASTICLIFE_CHOIR_NAME",
    IsPrivate = true,
    HasMaximumInstance = true,
    MaximumInstanceAllowed = 1,
    WorkerCapacity = 10,
    RelatedJob = {
        Job = "JOB_MONASTICLIFE_CHOIR",
        Behavior = "BEHAVIOR_WORK",
    },
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
	},
    GameRuleModifierList = {
        {
            DataType = "GAME_RULE_MODIFIER_CROP_YIELDS",
            ResourceList = {
                "RESOURCE_MANUSCRIPT",
                "RESOURCE_MONASTERY_MEAL",
                "RESOURCE_MONASTERY_CLOTHES",
                "RESOURCE_LEARNING_PLANTS",
                "RESOURCE_LEARNING_ANIMALS",
                "RESOURCE_LEARNING_ALCHEMY",
                "RESOURCE_LEARNING_MATHEMATICS",
            },
            YieldPercentage = 1.10,
            IsUntilRemoval = true,
            IsGlobal = true,
        },
    },
})

mod:overrideAsset({
    Id = "BUILDING_FUNCTION_LIST_MONASTERY",
    AssetFunctionList = {
        Action = "APPEND",
        "BUILDING_FUNCTION_MONASTICLIFE_CHOIR",
    }
})


