local mod = ...



-- Wall -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Monastery1.fbx/Prefab/Wall.Wall.Part", "PREFAB_MONASTICLIFE_WALL" )

-- Grounding
for i = 5, 6 do
    mod:registerPrefabComponent("models/Monastery1.fbx/Prefab/Wall.Wall.Part/Attach_Side." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

-- Attach type
mod:registerPrefabComponent("PREFAB_MONASTICLIFE_WALL", { DataType = "COMP_BUILDING_PART", BuildingPartType = "SIDE" })

-- Wall visuals
for i = 1, 4 do
    mod:registerAssetId("models/Monastery1.fbx/Prefab/Wall.Wall.Part.00" .. i, "PREFAB_MONASTICLIFE_WALL" .. i )
    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_MONASTICLIFE_WALL_WALL" .. i,
        Name = "BUILDING_PART_MONASTICLIFE_WALL_NAME",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_MONASTICLIFE_WALL" .. i,
            MiniatureConfig = {
                ClipUnderGround = true,
                GroupHeight = 0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0,
                CameraPitchOffset = 0.0
            },
        },
    })
end

-- Random pick wall visual
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_WALL_WALL",
    Name = "BUILDING_PART_MONASTICLIFE_WALL_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_MONASTICLIFE_WALL_WALL1",
            "BUILDING_PART_MONASTICLIFE_WALL_WALL2",
            "BUILDING_PART_MONASTICLIFE_WALL_WALL3",
            "BUILDING_PART_MONASTICLIFE_WALL_WALL4",
        },
    },
})

-- Assemble
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_WALL_ASSEMBLAGE",
    Name = "BUILDING_PART_MONASTICLIFE_WALL_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_MONASTICLIFE_WALL" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_MONASTICLIFE_WALL_WALL" }, -- from Fantasy Decorations
		},
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    -- BuildingZone = {
    --     ZoneEntryList = {
    --         {
    --             Polygon = polygon.createRectangle( {4.0, 2.25}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
    --         },
    --     },
    -- },
    -- Cost = UpgradeCostTools,
})

-- Final part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_WALL",
    Name = "BUILDING_PART_MONASTICLIFE_WALL_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_MONASTICLIFE_WALL_ASSEMBLAGE",
        },
    },
})



-- Pillar -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Monastery1.fbx/Prefab/Wall.Pillar.Part", "PREFAB_MONASTICLIFE_PILLAR" )

-- Grounding
for i = 1, 4 do
    mod:registerPrefabComponent("models/Monastery1.fbx/Prefab/Wall.Pillar.Part/Attach_Side." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

-- Attach type
mod:registerPrefabComponent("PREFAB_MONASTICLIFE_PILLAR", { DataType = "COMP_BUILDING_PART", BuildingPartType = "SIDE" })

-- Pillar visuals
for i = 1, 4 do
    mod:registerAssetId("models/Monastery1.fbx/Prefab/Wall.Pillar.Part.00" .. i, "PREFAB_MONASTICLIFE_PILLAR" .. i )
    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_MONASTICLIFE_PILLAR_PILLAR" .. i,
        Name = "BUILDING_PART_MONASTICLIFE_PILLAR_NAME",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_MONASTICLIFE_PILLAR" .. i,
            MiniatureConfig = {
                ClipUnderGround = true,
                GroupHeight = 0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0,
                CameraPitchOffset = 0.0
            },
        },
    })
end

-- Random pick visual
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_PILLAR_PILLAR",
    Name = "BUILDING_PART_MONASTICLIFE_PILLAR_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_MONASTICLIFE_PILLAR_PILLAR1",
            "BUILDING_PART_MONASTICLIFE_PILLAR_PILLAR2",
            "BUILDING_PART_MONASTICLIFE_PILLAR_PILLAR3",
            "BUILDING_PART_MONASTICLIFE_PILLAR_PILLAR4",
        },
    },
})

-- Assemble
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_PILLAR_ASSEMBLAGE",
    Name = "BUILDING_PART_MONASTICLIFE_PILLAR_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_MONASTICLIFE_PILLAR" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_MONASTICLIFE_PILLAR_PILLAR" }, -- from Fantasy Decorations
		},
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    -- BuildingZone = {
    --     ZoneEntryList = {
    --         {
    --             Polygon = polygon.createRectangle( {4.0, 2.25}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
    --         },
    --     },
    -- },
    -- Cost = UpgradeCostTools,
})

-- Final part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_PILLAR",
    Name = "BUILDING_PART_MONASTICLIFE_PILLAR_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_MONASTICLIFE_PILLAR_ASSEMBLAGE",
        },
    },
})



-- Gate -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Monastery1.fbx/Prefab/Wall.Gate.Part", "PREFAB_MONASTICLIFE_GATE" )

-- Grounding
for i = 7, 8 do
    mod:registerPrefabComponent("models/Monastery1.fbx/Prefab/Wall.Gate.Part/Attach_Side." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

-- Attach type
mod:registerPrefabComponent("PREFAB_MONASTICLIFE_GATE", { DataType = "COMP_BUILDING_PART", BuildingPartType = "SIDE" })

-- Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_GATE",
    Name = "BUILDING_PART_MONASTICLIFE_GATE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_MONASTICLIFE_GATE"
    },
})



-- Cross -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Monastery1.fbx/Prefab/Cross.Part.001", "PREFAB_MONASTICLIFE_CROSS1" )

-- Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_CROSS1",
    Name = "BUILDING_PART_MONASTICLIFE_CROSS_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_MONASTICLIFE_CROSS1",
    },
	BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {2, 2}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
			},
        },
	},
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 50 }
        },
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 10 }
        },
        ResourceNeededList = {
            {
                { Resource = "POLISHED_STONE", Quantity = 20 },
            },
            {
                { Resource = "TOOL", Quantity = 10 },
            },
        },
    },
    EstateSplendor = {
		{ Estate = "CLERGY", Quantity = 1 },
    },
})




-- Tower -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Monastery1.fbx/Prefab/Tower.Part.001", "PREFAB_MONASTICLIFE_TOWER1" )
mod:registerAssetId("models/Monastery1.fbx/Prefab/Tower.Part.001.Constr", "PREFAB_MONASTICLIFE_TOWER1_CONSTR" )

-- Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_MONASTICLIFE_TOWER1",
    Name = "BUILDING_PART_MONASTICLIFE_TOWER_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_MONASTICLIFE_TOWER1",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LARGE_BELL",
    ConstructionVisual = "PREFAB_MONASTICLIFE_TOWER1_CONSTR",
	BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 3.1, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
			},
        },
	},
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 200 }
        },
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 50 }
        },
        ResourceNeededList = {
            {
                { Resource = "WOOD", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 40 },
                { Resource = "TOOL", Quantity = 10 },
            },
            {
                { Resource = "WOOD", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 40 },
                { Resource = "TOOL", Quantity = 10 },
            },
            {
                { Resource = "WOOD", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 40 },
                { Resource = "TOOL", Quantity = 10 },
            },
            {
                { Resource = "WOOD", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 40 },
                { Resource = "TOOL", Quantity = 10 },
            },
            {
                { Resource = "WOOD", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 40 },
                { Resource = "TOOL", Quantity = 10 },
            },
        },
    },
    EstateSplendor = {
		{ Estate = "CLERGY", Quantity = 5 },
    },
})
