local mod = ...



-- Job: Scholar -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_MONASTICLIFE_SCHOLAR",
	JobName = "JOB_MONASTICLIFE_SCHOLAR_NAME",
	JobDescription = "JOB_MONASTICLIFE_SCHOLAR_DESC",
	IsLockedByDefault = true,
	DefaultBehavior = "BEHAVIOR_WORK",
	UseWorkplaceBehavior = true,
    ProductionDelay = 60, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		LeftHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_ENVOY_SCROLL"
		},
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE",
	},
})

mod:overrideAsset({
    Id = "MONK",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_MONASTICLIFE_SCHOLAR",
    },
})

mod:overrideAsset({
    Id = "MONK_PRIOR",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_MONASTICLIFE_SCHOLAR",
    },
})



-- Building Function: Scholar --------------------------------------------------------------------------------------------
local function registerScholar(name)
    mod:registerAsset({
        DataType = "BUILDING_FUNCTION_WORKPLACE",
        Id = "BUILDING_FUNCTION_MONASTICLIFE_SCHOLAR_" .. name,
        Name = "BUILDING_FUNCTION_MONASTICLIFE_SCHOLAR_" .. name .. "_NAME",
        IsPrivate = true,
        HasMaximumInstance = true,
        MaximumInstanceAllowed = 1,
        WorkerCapacity = 4,
        RelatedJob = {
            Job = "JOB_MONASTICLIFE_SCHOLAR",
            Behavior = "BEHAVIOR_WORK",
        },
        InputInventoryCapacity = {
            { Resource = "RESOURCE_MANUSCRIPT", Quantity = 10 },
            { Resource = "CANDLE", Quantity = 10 },
        },
        ResourceListNeeded = {
            { Resource = "RESOURCE_MANUSCRIPT", Quantity = 1 },
            { Resource = "CANDLE", Quantity = 1 },
        },
        ResourceProduced = {
            { Resource = "RESOURCE_LEARNING_" .. name, Quantity = 1 },
        },
    })
end

registerScholar("PLANTS")
-- registerScholar("ANIMALS") -- planned for a future mod, limitations and issues with having workplace upgrades in livestock monuments
registerScholar("ALCHEMY")
registerScholar("MATHEMATICS")



-- Append to Monastery
mod:overrideAsset({
    Id = "BUILDING_FUNCTION_LIST_MONASTERY",
    AssetFunctionList = {
        Action = "APPEND",
        "BUILDING_FUNCTION_MONASTICLIFE_SCHOLAR_PLANTS",
        -- "BUILDING_FUNCTION_MONASTICLIFE_SCHOLAR_ANIMALS",
        "BUILDING_FUNCTION_MONASTICLIFE_SCHOLAR_ALCHEMY",
        "BUILDING_FUNCTION_MONASTICLIFE_SCHOLAR_MATHEMATICS",
    },
})
