local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Upgrade1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Upgrade2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/Upgrade1.fbx/Materials/Material.Thatch.Edge", "MATERIAL_MONASTICLIFE_THATCHEDGE")
mod:overrideAsset({
    Id = "MATERIAL_MONASTICLIFE_THATCHEDGE",
    HasAlphaTest = true,
})



-- Part Type -------------------------------------------------------------------------------------
mod:registerEnumValue("BUILDING_PART_TYPE", "UPGRADE")


-- -- Attach Type
-- mod:registerPrefabComponent("PREFAB_MONASTICLIFE_UPGRADE_" .. name, {
-- 	DataType = "COMP_BUILDING_PART",
-- 	BuildingPartType = "MINOR",
-- })

-- -- Grounding
-- mod:registerPrefabComponent("models/Monastery1.fbx/Prefab/Sheep.Part.001/Hay.003", {DataType = "COMP_GROUNDED"})



-- Building Function: Double Production --------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION",
    Id = "BUILDING_FUNCTION_MONASTICLIFE_UPGRADE_TOOLS",
    Name = "BUILDING_PART_MONASTICLIFE_UPGRADE_TOOLS_NAME",
    GameRuleModifierList = {
        {
            DataType = "GAME_RULE_MODIFIER_WORKPLACE_RECIPE",
            ProductionMultiplier = 2, -- although a float, this only works with integers as of Jan 2022
        },
    },
})



-- Common Costs --------------------------------------------------------------------------------------
UpgradeCostTools = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_PLANTS", Quantity = 50 },
        { Resource = "GOLD_COINS", Quantity = 200 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 50 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
        },
    },
}

UpgradeCostField = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_PLANTS", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 100 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 25 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 10 },
            { Resource = "WOOD", Quantity = 5 },
        },
    },
}

UpgradeCostMethods = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_ALCHEMY", Quantity = 50 },
        { Resource = "GOLD_COINS", Quantity = 200 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 50 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
        },
    },
}

UpgradeCostMachinery = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_MATHEMATICS", Quantity = 50 },
        { Resource = "GOLD_COINS", Quantity = 200 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 50 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
        },
    },
}

